# Generated by Django 4.1.4 on 2022-12-31 16:41

import pathlib

import main.models
from django.conf import settings
from django.db import migrations


def move_files(apps, schema_editor):
    Invoice = apps.get_model("main", "Invoice")
    Snapshot = apps.get_model("main", "Snapshot")

    for invoice in Invoice.objects.all():
        print(f"Invoice {invoice.pk}")
        if invoice.file is None:
            invoice.delete()
            continue
        try:
            initial_path = pathlib.Path(invoice.file.path)
        except ValueError:
            invoice.delete()
            continue
        if invoice.file is None or not initial_path.exists():
            print(f"!!! Path {initial_path} does not exist")
            invoice.delete()
            continue
        prev_file = invoice.file.path
        invoice.file.save(main.models.get_path(invoice, None), invoice.file)
        pathlib.Path(prev_file).unlink()

    for snapshot in Snapshot.objects.filter(file__isnull=False):
        print(f"Snapshot {snapshot.pk}")
        try:
            initial_path = pathlib.Path(snapshot.file.path)
        except ValueError:
            snapshot.file = None
            snapshot.save()
            continue
        if not initial_path.exists():
            print(f"!!! Path {initial_path} does not exist")
            snapshot.file = None
            snapshot.save()
            continue
        prev_file = snapshot.file.path
        snapshot.file.save(main.models.get_path(snapshot, None), snapshot.file)
        pathlib.Path(prev_file).unlink()


class Migration(migrations.Migration):
    dependencies = [
        ("main", "0022_alter_account_icon_alter_category_icon"),
    ]

    operations = [migrations.RunPython(move_files)]
